 Member
_ABCDllMode_  EQUATE(0)
_ABCLinkMode_ EQUATE(1)

 Map
   Module('api')
     MultiByteToWideChar(UNSIGNED,ulong,*cstring,SIGNED,long,SIGNED),SIGNED,PASCAL,RAW,proc,name('MultiByteToWideChar')
     memcpy(long,long,signed),long,proc,name('_Memcpy')
     lstrlenW(long lpWString),signed,proc,pascal
     widecharToMultibyte(ulong,ulong,Long,long,long,Long,long,long),bool,pascal,raw,proc
   end
 end

!Includes this class and others
include('strcl.inc')

!global data for this module
cp_acp          equate(0)
Return:Benign   equate(0)
Return:Notify   equate(5)
Return:Fatal    equate(3)

!-------------------------------------------------------------
!---Start of string class
!-------------------------------------------------------------
strclType.Init                  Procedure()
  Code
  Return

strclType.Kill              Procedure()
!destroy any dynamic objects and clean up
    Code
    RETURN

strcltype.CWToWideStr Procedure(String pInputstr, *String pOutputStr)
cStr        &Cstring
InputSize   long,auto
res         byte,auto
  code
  InputSize = len(Clip(pInputStr))
  cStr &= NEW(cstring(InputSize+1))
  If cstr &= NULL then Return(Return:Fatal).
  cstr = clip(pInputStr)
  res=SELF.CtoWideStr(cstr, pOutputStr)
  dispose(cstr)
  Return(Res)

strcltype.CWToWideStrAlloc Procedure(String pInputstr)!,*String
cStr        &Cstring
InputSize   long,auto
OutputStr   &String
  Code
  InputSize = len(Clip(pInputStr))
  cStr &= NEW(cstring(InputSize+1))
  If cstr &= NULL then Return OutputStr.
  cstr = clip(pInputStr)
  OutputStr &= SELF.CtoWideStrAlloc(cstr)
  dispose(cstr)
  Return OutputStr

StrClType.CtoWideStrAlloc Procedure(*cstring pInputStr)!,*string
InputSize   long,auto
res byte,auto
NeededSize  long,auto
WideBytesWritten long,auto
OutputStr   &String
  code
  InputSize = len(pInputStr)
  NeededSize = MultiByteToWideChar(CP_ACP, 0, pInputstr, InputSize, 0, 0)
  If ~NeededSize then Return OutputStr.
  !CONVERT FROM SIZE t TO BYTES
  NeededSize = (NeededSize*2)+2
  OutputStr &= New(String(NeededSize))
  If Outputstr &= NULL then Return OutputStr.

  WidebytesWritten = MultiByteToWideChar(CP_ACP,0,pInputStr, InputSize, address(OutputStr),Size(OutputStr) )
  Outputstr[Neededsize]='<0>'
  Outputstr[Neededsize-1]='<0>'
  Return OutputStr


StrClType.CWtoBstr Procedure(String pInputStr, *String pOutputstr)
cStr        &Cstring
InputSize   long,auto
res         byte,auto
  code
  InputSize = len(Clip(pInputStr))
  cStr &= NEW(cstring(InputSize+1))
  If cstr &= NULL then Return(Return:Fatal).
  cstr = clip(pInputStr)
  res=SELF.CtoBStr(cstr, pOutputStr)
  dispose(cstr)
  Return(Res)


StrClType.CtoWideStr Procedure(*cstring pInputStr, *String pOutputStr)
InputSize   long,auto
res byte,auto
NeededSize  long,auto
WideBytesWritten long,auto
  code
  InputSize = len(pInputStr)
  NeededSize = MultiByteToWideChar(CP_ACP, 0, pInputstr, InputSize, 0, 0)
  If ~NeededSize then do ProcedureReturn.
  !CONVERT FROM SIZE t TO BYTES
  NeededSize = (NeededSize*2)+2
  If Size(pOutputStr)< Neededsize then Res=Return:notify;do ProcedureReturn.

  WidebytesWritten = MultiByteToWideChar(CP_ACP,0,pInputStr, InputSize, address(pOutputStr),Size(pOutputStr) )
  pOutputstr[Neededsize]='<0>'
  pOutputstr[Neededsize-1]='<0>'
  If WideBytesWritten then Res = Return:Benign.
  Do ProcedureReturn

ProcedureReturn Routine
  Return(Res)

StrClType.CToBStr Procedure(*CString pInputStr, *String pOutputStr)
InputSize   long,auto
NeededSize  long,auto
res         byte(Return:Fatal)
WideBytesWritten long,auto
  code
  !make the input string as cstring
  InputSize = len(pInputStr)

  !Get the required buffer size
  NeededSize = MultiByteToWideChar(CP_ACP, 0, pInputStr, InputSize, 0, 0)
  If ~NeededSize then do ProcedureReturn.
  NeededSize =(NeededSize*2)+6 !add for the length preceeding and null after
  If Size(pOutputStr)< NeededSize then Res=Return:notify;do ProcedureReturn.

  !make the wide string
  WideBytesWritten = MultiByteToWideChar(CP_ACP,0,pInputStr, InputSize, address(pOutputStr)+4,Size(pOutputStr)-4 )
  If ~WideBytesWritten then do ProcedureReturn.
  pOutputstr[Neededsize]='<0>'
  pOutputStr[NeededSize-1]='<0>'

  !Write the length long
  InputSize *= 2
  memcpy(Address(pOutputStr), address(InputSize), 4)
  Res=Return:Benign
  Do ProcedureReturn
ProcedureReturn Routine
  Return(Res)

StrClType.WideToCWStr     Procedure(long plpwideStr, *string pOutputStr)!,byte,proc
cStr        &Cstring
ReqLen      Long,auto
res         byte(Return:Fatal)
charWritten long,auto
  Code
  !make the intermediate cstring
  ReqLen = lstrlenw(plpWideStr)
  If ~ReqLen then Clear(pOutputstr);return(Return:Benign).
  If size(pOutputStr)<reqLen then return(Return:notify). !output buffer too short
  cstr &= new(cstring(ReqLen+1))
  If cstr &= Null then return(Res).

  !convert to cstring
  CharWritten=WideCharToMultiByte(|
    0,| !codePage Ansi
    0,| !Flags
    plpwidestr,| !inputstring
    ReqLen,|      !pass the length
    Address(cStr),|   !output
    ReqLen+1,|
    0,| !default char (none specified)
    0) !lpboolean flag as to if default char used
    If ~CharWritten then do ProcedureReturn.

   Res = Return:Benign
   pOutputStr = cstr
   do ProcedureReturn
ProcedureReturn Routine
  Dispose(cStr)
  Return(Res)

StrClType.WideToCStr     Procedure(long plpwideStr, *cstring pOutputStr)!,byte,proc
ReqLen      Long,auto
res         byte(Return:Fatal)
charWritten long,auto
  Code
  !make the intermediate cstring
  Clear(pOutputStr)
  ReqLen = lstrlenw(plpWideStr)
  If ~ReqLen then return(Return:Benign). !blank string
  If size(pOutputStr)-1<reqLen then return(Return:notify). !output buffer too short

  !convert to cstring
  clear(pOutputStr)
  CharWritten=WideCharToMultiByte(|
    0,| !codePage Ansi
    0,| !Flags
    plpwidestr,| !inputstring
    ReqLen,|      !pass the length
    Address(pOutputStr),|   !output
    Size(pOutputStr)-1,|
    0,| !default char (none specified)
    0) !lpboolean flag as to if default char used
    If ~CharWritten then do ProcedureReturn.
    pOutputstr[charwritten+1]='<0>'

   Res=Return:Benign
   do ProcedureReturn
ProcedureReturn Routine
  Return(Res)


StrClType.BSTRToCWStr     Procedure(long plpwideStr, *string pOutputStr)!,byte,proc
  Code
  If ~plpWideStr then Clear(pOutputStr);Return(Return:Fatal).
  Return(SELF.WideToCWStr(plpWideStr,pOutputStr))

StrClType.BSTRToCStr     Procedure(long plpwideStr, *cstring pOutputStr)!,byte,proc
  Code
  If ~plpWideStr then Clear(pOutputStr);Return(Return:Fatal).
  Return(SELF.WideToCStr(plpWideStr,pOutputStr))






